<Cabbage>
;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour(56,255,182,255) outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define RSLIDER colour(56,150,180,255) trackerColour("MediumTurquoise") fontColour("Gainsboro") valueTextBox(1) textBoxColour("black") 
#define FONT fontColour("white")

form caption("Stringy") size(630,580), guiMode("queue"), pluginId("KS01")
label channel("l1") bounds(5,5,58,17) text("Presets") fontColour("white")
combobox bounds(62,5,110,17) populate("*.snaps") channelType("string") channel("cb1") ;$FONT
filebutton bounds(175,5,37,17) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(215,5,50,17) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1) 

label channel("l2") bounds(5,30,50,17) text("Input") fontColour("white")
button bounds(62,30,55,17) channel("liveon") text("Mic/Line") $BUTTONS
combobox bounds(122,30,50,17) channel("livech") text("Stereo","Mono") value(1)
rslider bounds(175,27,25,25) channel("liveamp") range(0,5,.5,0.75,0.001) $BASIC
filebutton bounds(62,55,55,17) channel("openFile") text("Load SF") $BUTTONS
button bounds(122,55,50,17) channel("sfplay") text("Play") $BUTTONS
button bounds(175,55,35,17) channel("sfloop") text("Loop") $BUTTONS
rslider bounds(215,52,25,25) channel("sfamp") range(0,5,1.0,0.75,0.001) $BASIC

button bounds(530,55,97,25) channel("stream") text("Stream Off","Stream On") colour("MediumTurquoise") fontColour("white") presetIgnore(1)
rslider channel("streamrate") bounds(535,85,60,45) range(.01,50,5,1,.01) popupText("note rate") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamraterand") bounds(575,85,60,45) range(0,.99,0,1,.01) popupText("rate random") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
combobox bounds(530,140,95,17) channel("noteconstrain") text("unconstrained","equal temperament") presetIgnore(1) value(1)
rslider channel("streamnote") bounds(535,165,60,45) range(0,127,60,1,1) popupText("MIDI note") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamnoterand") bounds(575,165,60,45) range(0,72,0,1,.01) popupText("random MIDI range") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamamp") bounds(535,215,60,45) range(0,1,.76,1,.01) popupText("amp") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamamprand") bounds(575,215,60,45) range(0,.99,0,.5,.01) popupText("amp random") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamdur") bounds(535,265,60,45) range(.01,15,.5,.5,.01) popupText("dur") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER
rslider channel("streamdurrand") bounds(575,265,60,45) range(0,.99,0,.5,.01) popupText("dur random") valueTextBox(1) textBoxColour("black") presetIgnore(1) $RSLIDER

button bounds(530,5,47,25) channel("record") text("Record","Stop") colour("red") fontColour("white")  presetIgnore(1) 
combobox bounds(530,35,47,15) channel("recch") value(2) text("mono","stereo")  presetIgnore(1) value(1)
combobox bounds(580,35,47,15) channel("bit") value(1) text("16-bit","24-bit","32-bit")  presetIgnore(1) value(1)
button bounds(580,5,47,25) channel("play") text("Play") colour("MediumTurquoise") fontColour("white")  presetIgnore(1) 

combobox channel("src") bounds(5,85,100,17) text("white noise","pink noise","static","sawtooth","sine","square","pulse","soundfile","mic") value(1)
button bounds(5,105,75,17) channel("exp") text("linear","exponential") $BUTTONS
rslider channel("exC") bounds(105,80,70,45) range(-24,24,0,1,1) popupText("Osc Coarse") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("exF") bounds(165,80,70,45) range(-1,1,0,1,.01) popupText("Osc Fine") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("att") bounds(15,125,70,45) range(.001,10,.01,.5,.001) popupText("attack") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("dec") bounds(75,125,70,45) range(.001,10,.01,.5,.001) popupText("decay") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("sus") bounds(135,125,70,45) range(0,.999,0,1,.001) popupText("sustain") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("rel") bounds(195,125,70,45) range(.001,10,.05,.5,.001) popupText("release") valueTextBox(1) textBoxColour("black") $RSLIDER
combobox channel("filt") bounds(5,180,100,17) text("low pass","high pass","band pass","band reject") value(1)
label channel("l10") bounds(120,180,100,17) text("input filter") $FONT
label channel("l10") bounds(55,265,150,17) text("string filter") $FONT

rslider channel("coF") bounds(65,205,70,55) range(50,20000,5000,.5,1) popupText("cutoff F") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Q") bounds(125,205,70,55) range(.5,100,5,1,.1) popupText("Q") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("stat") bounds(185,205,70,55) range(.25,100,15,1,.1) popupText("Static Rate") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pluck") bounds(65,285,70,55) range(.01,.99,.15,1,.01) popupText("Pluck Position") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("lp") bounds(125,285,70,55) range(50,20000,10000,.5,1) popupText("string low pass") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("ref") bounds(65,345,70,55) range(0,.9999,.995,5,.0001) popupText("reflection coefficient") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("srel") bounds(125,345,70,55) range(.001,15,.5,1,.001) popupText("string release") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("vol") bounds(185,345,70,55) range(0,5,1,1,.01) popupText("volume") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("coFrnd") bounds(5,205,60,45) range(0,20000,0,.5,.1) popupText("filter random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pluckrnd") bounds(5,285,60,45) range(0,.9,0,.5,.001) popupText("pluck random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("lprnd") bounds(185,285,60,45) range(0,20000,0,.5,1) popupText("low pass random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Frnd") bounds(475,85,60,45) range(0,24,0,.5,.001) popupText("tune random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("posrnd") bounds(475,145,60,45) range(0,.9,0,.5,.001) popupText("color random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("mixrnd") bounds(475,205,60,45) range(0,.9,0,.5,.001) popupText("mix random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("panrnd") bounds(475,265,60,45) range(0,.9,0,.5,.001) popupText("pan random") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("amprnd") bounds(475,325,60,45) range(0,.9,0,.5,.001) popupText("amp random") valueTextBox(1) textBoxColour("black") $RSLIDER

label channel("l3") bounds(275,5,70,17) text("String 1") fontColour("white") align("centre")
rslider channel("C1") bounds(275,25,70,55) range(-24,24,0,1,1) popupTex("Coarse Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("F1") bounds(275,85,70,55) range(-1,1,0,1,.01) popupTex("Fine Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pos1") bounds(275,145,70,55) range(0,.999,0,1,.001) popupText("string 1 color") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("mix1") bounds(275,205,70,55) range(0,1,.15,.5,.001) popupText("string 1 mix") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pan1") bounds(275,265,70,55) range(0,1,.5,1,.01) popupText("string 1 pan") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("amp1") bounds(275,325,70,55) range(0,1.5,1,1,.01) popupText("string 1 amp") valueTextBox(1) textBoxColour("black") $RSLIDER
nslider bounds(285,385,50,20) channel("up1") range(-24,24,2,1,.01)
nslider bounds(285,405,50,20) channel("down1") range(-24,24,2,1,.01)

label channel("l4") bounds(345,5,70,17) text("String 2") fontColour("white") align("centre")
rslider channel("C2") bounds(345,25,70,55) range(-24,24,0,1,1) popupTex("Coarse Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("F2") bounds(345,85,70,55) range(-1,1,0,1,.01) popupTex("Fine Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pos2") bounds(345,145,70,55) range(0,.999,0,1,.001) popupText("string 2 color") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("mix2") bounds(345,205,70,55) range(0,1,.15,.5,.001) popupText("string 2 mix") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pan2") bounds(345,265,70,55) range(0,1,.5,1,.01) popupText("string 2 pan") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("amp2") bounds(345,325,70,55) range(0,1.5,1,1,.01) popupText("string 2 amp") valueTextBox(1) textBoxColour("black") $RSLIDER
nslider bounds(355,385,50,20) channel("up2") range(-24,24,2,1,.01)
nslider bounds(355,405,50,20) channel("down2") range(-24,24,2,1,.01)

label channel("l5") bounds(415,5,70,17) text("String 3") fontColour("white") align("centre")
rslider channel("C3") bounds(415,25,70,55) range(-24,24,0,1,1) popupTex("Coarse Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("F3") bounds(415,85,70,55) range(-1,1,0,1,.01) popupTex("Fine Tuning") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pos3") bounds(415,145,70,55) range(0,.999,0,1,.001) popupText("string 3 color") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("mix3") bounds(415,205,70,55) range(0,1,.15,.5,.001) popupText("string 3 mix") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("pan3") bounds(415,265,70,55) range(0,1,.5,1,.01) popupText("string 3 pan") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("amp3") bounds(415,325,70,55) range(0,1.5,1,1,.01) popupText("string 3 amp") valueTextBox(1) textBoxColour("black") $RSLIDER
nslider bounds(425,385,50,20) channel("up3") range(-24,24,2,1,.01)
nslider bounds(425,405,50,20) channel("down3") range(-24,24,2,1,.01)

rslider channel("npo") bounds(535,325,60,45) range(3,48,12,.5,.01) popupText("notes per octave") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("basenn") bounds(575,325,60,45) range(0,127,60,1,1) popupText("base MIDI note") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("res1") bounds(5,425,70,45) range(2,10000,50,1,.1) popupText("resonant F") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Q1") bounds(50,425,70,45) range(.5,100,4,1,.1) popupText("Q") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("resamp1") bounds(95,425,70,45) range(0,1.5,1,1,.01) popupText("resonant amp") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("res2") bounds(145,425,70,45) range(2,10000,150,1,.1) popupText("resonant F") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Q2") bounds(190,425,70,45) range(.5,100,4,1,.1) popupText("Q") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("resamp2") bounds(235,425,70,45) range(0,1.5,1,1,.01) popupText("resonant amp") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("res3") bounds(285,425,70,45) range(2,10000,500,1,.1) popupText("resonant F") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Q3") bounds(330,425,70,45) range(.5,100,4,1,.1) popupText("Q") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("resamp3") bounds(375,425,70,45) range(0,1.5,1,1,.01) popupText("resonant amp") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("res4") bounds(425,425,70,45) range(2,10000,1050,1,.1) popupText("resonant F") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("Q4") bounds(470,425,70,45) range(.5,100,4,1,.1) popupText("Q") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("resamp4") bounds(515,425,70,45) range(0,1.5,1,1,.01) popupText("resonant amp") valueTextBox(1) textBoxColour("black") $RSLIDER

rslider channel("resFB") bounds(515,380,70,45) range(0,.1,.01,1,.001) popupText("resonance mix") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("revtime") bounds(565,380,70,45) range(0,5,.1,1,.01) popupText("reverb time") valueTextBox(1) textBoxColour("black") $RSLIDER
rslider channel("resmix") bounds(565,425,70,45) range(0,1,.1,1,.001) popupText("reverb mix") valueTextBox(1) textBoxColour("black") $RSLIDER


keyboard bounds(8,478,611,95)
</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 ;--midi-key-cps=4
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps=32
nchnls=2
0dbfs=1

massign 0,10
alwayson 1
alwayson 750
gafinalL,gafinalR,garesFB init 0
gamicL,gamicR,gasfL,gasfR init 0
galiveL,galiveR,galiveRM,galiveAM init 0
gkliveFM init 0
gkstatus,gkchan,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
giTable init 501
gkRecordingActiveFlag,gkFileRecorded init 0

;This model has three strings--one at the base cps, the other two as per the Dudas model with +-k

instr 1   ;live audio input and record/play control
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
;    chnset SIdentString, "filer"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
kliveon port kliveon,.025
klivech chnget "livech"
kliveamp chnget "liveamp"

ainL,ainR ins
ainL=ainL*kliveon*kliveamp
ainR=ainR*kliveon*kliveamp
if klivech=1 then
gamicL=ainL
gamicR=ainR
else
gamicL=ainL+ainR
gamicR=ainL+ainR
endif

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
  
kstream chnget "stream"
if changed(kstream)==1 then
  if kstream=1 then
    event "i",5,0,999999
  else
    turnoff2 5,0,0
  endif
endif

endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    asfL=a1*kingain*kEnv;*ksfon ;add output into global audio mix
    asfR=a1*kingain*kEnv;*ksfon
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    asfL=a1*kingain*kEnv;*ksfon
    asfR=a2*kingain*kEnv;*ksfon
    endif
    outs asfL,asfR
endin

instr 3
giTable ftgen   501,0,0,1,gSfilepath,0,0,0
gichnls filenchnls  gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen    init    ftlen(giTable)/gichnls
Smessage    sprintfk    "file(%s)", gSfilepath
endin

instr 5 ;generates random note stream to drive instr 10
kstreamrate chnget "streamrate"
kstreamraterand chnget "streamraterand"
kstreamnote chnget "streamnote"
kstreamnoterand chnget "streamnoterand"
kstreamamp chnget "streamamp"
kstreamamprand chnget "streamamprand"
kstreamdur chnget "streamdur"
kstreamdurrand chnget "streamdurrand"
kconstrain chnget "noteconstrain"
kraterand randh kstreamrate*kstreamraterand,kstreamrate,2
krate2=kstreamrate+kraterand
krate limit krate2,.01,100 ;master note rate within set limits
ktrig metro krate
 if ktrig==1 then
 knote=limit(kstreamnote+random(-kstreamnoterand,kstreamnoterand),10,127)
  if kconstrain=1 then
  knote=knote
  else
  knote=int(knote)
  endif
 kamp=limit(kstreamamp+random(-kstreamamprand*kstreamamp,kstreamamprand*kstreamamp),.01,1)
 kdur=limit(kstreamdur+random(-kstreamdurrand*kstreamdur,kstreamdurrand*kstreamdur),.01,30)
 event "i",10,0,kdur,knote,kamp
 endif
endin

instr 10 ;p4=MIDI note number, p5=amp in dB
iFrnd chnget "Frnd"
iposrnd chnget "posrnd"
imixrnd chnget "mixrnd"
icoFrnd chnget "coFrnd"
ipluckrnd chnget "pluckrnd"
ilprnd chnget "lprnd"
ipanrnd chnget "panrnd"
iamprnd chnget "amprnd"
kexp chnget "exp"

ascatL init 0
ascatR init 0
kpluck chnget "pluck"
kpluck=kpluck+random(-ipluckrnd,ipluckrnd)
if kpluck>.999 then
kpluck=.999
elseif kpluck<.001 then
kpluck=.001
endif
kref chnget "ref" ;get reflection coefficient
kvol chnget "vol" ;master volume control
kpos1 chnget "pos1" ;determines deviation from base cps for strings 2&3, % of delay added to one/subtracted from other
kpos1=kpos1+random(-iposrnd,iposrnd)
if kpos1<.001 then 
kpos1=.001
elseif kpos1>.999 then
kpos1=.999
endif
kmix1 chnget "mix1" ;mix between detuned and base F strings
kmix1=kmix1+random(-imixrnd,imixrnd)
if kmix1<.001 then 
kmix1=.001
elseif kmix1>.999 then
kmix1=.999
endif
kpos2 chnget "pos2" ;determines deviation from base cps for strings 2&3, % of delay added to one/subtracted from other
kpos2=kpos2+random(-iposrnd,iposrnd)
if kpos2<.001 then 
kpos2=.001
elseif kpos2>.999 then
kpos2=.999
endif
kmix2 chnget "mix2" ;mix between detuned and base F strings
kmix2=kmix2+random(-imixrnd,imixrnd)
if kmix2<.001 then 
kmix2=.001
elseif kmix2>.999 then
kmix2=.999
endif
kpos3 chnget "pos3" ;determines deviation from base cps for strings 2&3, % of delay added to one/subtracted from other
kpos3=kpos3+random(-iposrnd,iposrnd)
if kpos3<.001 then 
kpos3=.001
elseif kpos3>.999 then
kpos3=.999
endif
kmix3 chnget "mix3" ;mix between detuned and base F strings
kmix3=kmix3+random(-imixrnd,imixrnd)
if kmix3<.001 then 
kmix3=.001
elseif kmix3>.999 then
kmix3=.999
endif
kC1 chnget "C1"
kF1 chnget "F1"
kF1=kF1+random(-iFrnd,iFrnd)
kpan1 chnget "pan1"
kpan1=kpan1+random(-ipanrnd,ipanrnd)
if kpan1<0 then
kpan1=0
elseif kpan1>1 then
kpan1=1
endif
kamp1 chnget "amp1"
kamp1=kamp1+random(-iamprnd,iamprnd)
if kamp1<0 then
kamp1=0
endif
kC2 chnget "C2"
kF2 chnget "F2"
kF2=kF2+random(-iFrnd,iFrnd)
kpan2 chnget "pan2"
kpan2=kpan2+random(-ipanrnd,ipanrnd)
if kpan2<0 then
kpan2=0
elseif kpan2>1 then
kpan2=1
endif
kamp2 chnget "amp2"
kamp2=kamp2+random(-iamprnd,iamprnd)
if kamp2<0 then
kamp2=0
endif
kC3 chnget "C3"
kF3 chnget "F3"
kF3=kF3+random(-iFrnd,iFrnd)
kpan3 chnget "pan3"
kpan3=kpan3+random(-ipanrnd,ipanrnd)
if kpan3<0 then
kpan3=0
elseif kpan3>1 then
kpan3=1
endif
kamp3 chnget "amp3"
kamp3=kamp3+random(-iamprnd,iamprnd)
if kamp3<0 then
kamp3=0
endif
krevtime chnget "revtime"
iatt chnget "att" ;these are all imposed on the input excitation source
idec chnget "dec"
isus chnget "sus"
irel chnget "rel"
isrel chnget "srel"
klp chnget "lp"
klp=klp+random(-ilprnd,ilprnd)
if klp<50 then
klp=50
elseif klp>20000 then
klp=20000
endif

kenv madsr .01,.01,.999,isrel
kresenv madsr .01,.01,.999,isrel+i(krevtime)
koscenv madsr iatt,idec,isus,irel
if kexp==1 then
koscenv=koscenv^3
endif

ksrc chnget "src"
kstat chnget "stat"

kup1 chnget "up1"
kup2 chnget "up2"
kup3 chnget "up3"
kdown1 chnget "down1"
kdown2 chnget "down2"
kdown3 chnget "down3"
kbend pchbend 0,1 ;provides normalized pitch bend value
kbend portk kbend,.05
  if kbend >= 0 then
  kbend1=kbend*kup1
  kbend2=kbend*kup2
  kbend3=kbend*kup3
  else
  kbend1=kbend*kdown1
  kbend2=kbend*kdown2
  kbend3=kbend*kdown3
  endif
kexC chnget "exC"
kexF chnget "exF"
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
;aburst linseg 0,iatt,p5,idec,0 ;work on providing a bunch of different noise bursts for greater tonal variance
knpo chnget "npo" ;get number of notes per octave
kbasenn chnget "basenn"
;kbasecps mtof kbasenn
ksc=12/knpo ;provides simple factor to be used in cps calculations
kexcitecps=mtof(((kbasenn+(p4-kbasenn))+kexC+kexF+kbend1)*ksc)

if ksrc==1 then ;CHECK MY IF THEN STRUCTURES TO FIX
aimpulse rand p5*koscenv
elseif ksrc==2 then
aimpulse pinkish p5*koscenv
elseif ksrc==3 then
aimpulse dust p5*koscenv,kstat
elseif ksrc==4 then
aimpulse oscil p5*koscenv*.2,kexcitecps,1 ;saw
elseif ksrc==5 then
aimpulse oscil p5*koscenv*.2,kexcitecps,2 ;sine
elseif ksrc==6 then
aimpulse oscil p5*koscenv*.2,kexcitecps,3 ;square
elseif ksrc==7 then
aimpulse oscil p5*koscenv*.2,kexcitecps,4 ;pulse
elseif ksrc==8 then
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    asfL=a1*kingain
    asfR=a1*kingain
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    asfL=a1*kingain
    asfR=a2*kingain
    endif
aimpulse=(asfL+asfR)*.7*p5
elseif ksrc==9 then
aimpulse=(gamicL+gamicR)*.7*p5 ;mic input into Cabbage is messed up--check more on MOTU audio routing!!!!!
endif

apick vdelay aimpulse,(1000/kexcitecps)*kpluck,250
aimpulse=(aimpulse-apick)*.5 ;this creates a simple inverse comb filter

;also tie filter cps to note cps?
kfilt chnget "filt" ;filter choice
kcoF chnget "coF" ;get filter cutoff frequency
kcoF=kcoF+random(-icoFrnd,icoFrnd)
if kcoF<50 then
kcoF=50
elseif kcoF>20000 then
kcoF=20000
endif
kQ chnget "Q" ;get filter Q
if kfilt==1 then
aimpfilt tone aimpulse,kcoF ;lowpass on impulse for high frequency damping
elseif kfilt==2 then
aimpfilt atone aimpulse,kcoF ;high pass
elseif kfilt==3 then
aimpfilt reson aimpulse,kcoF,kcoF/kQ ;band pass
aimpfilt balance aimpfilt,aimpulse
elseif kfilt==4 then
aimpfilt areson aimpulse,kcoF,kcoF/kQ ;band reject
aimpfilt balance aimpfilt,aimpulse
endif

kresmix chnget "resmix"
kresFB chnget "resFB"

ksmp1=sr/(mtof(kbasenn+(((p4+kC1+kF1+kbend1)-kbasenn)*ksc)))  ;something wrong with my calculations--refigure!
ksmp2=sr/(mtof(kbasenn+(((p4+kC2+kF2+kbend2)-kbasenn)*ksc)))
ksmp3=sr/(mtof(kbasenn+(((p4+kC3+kF3+kbend3)-kbasenn)*ksc)))

;FIRST SET OF STRINGS
kpos1=ksmp1*kpos1
ksmpint1A=int(ksmp1+kpos1) ;offset two of the strings from the base delay as per Dudas model
ksmpfrac1A=frac(ksmp1+kpos1)
ksmpint1B=int(ksmp1-kpos1)
ksmpfrac1B=frac(ksmp1-kpos1)
ksmpint1C=int(ksmp1)
ksmpfrac1C=frac(ksmp1)

abuf1A delayr 2.5
adel1A deltapn ksmpint1A
adel1A1 delay1 adel1A
afractdel1A=(adel1A*(1-ksmpfrac1A))+(adel1A1*ksmpfrac1A)
afractdel1A tone afractdel1A,klp
adel1B deltapn ksmpint1B
adel1B1 delay1 adel1B
afractdel1B=(adel1B*(1-ksmpfrac1B))+(adel1B1*ksmpfrac1B)
afractdel1B tone afractdel1B,klp
adel1C deltapn ksmpint1C
adel1C1 delay1 adel1C
afractdel1C=(adel1C*(1-ksmpfrac1C))+(adel1C1*ksmpfrac1C)
afractdel1C tone afractdel1C,klp
amix1=(aimpfilt+(garesFB*kresFB)+((afractdel1A+afractdel1B)*kmix1*.5)+(afractdel1C*(1-kmix1)))*kref ;add garesFB here
delayw amix1

;SECOND SET OF STRINGS
kpos2=ksmp2*kpos2
ksmpint2A=int(ksmp2+kpos2)
ksmpfrac2A=frac(ksmp2+kpos2)
ksmpint2B=int(ksmp2-kpos2)
ksmpfrac2B=frac(ksmp2-kpos2)
ksmpint2C=int(ksmp2)
ksmpfrac2C=frac(ksmp2)

abuf2A delayr 2.5
adel2A deltapn ksmpint2A
adel2A1 delay1 adel2A
afractdel2A=(adel2A*(1-ksmpfrac2A))+(adel2A1*ksmpfrac2A)
afractdel2A tone afractdel2A,klp
adel2B deltapn ksmpint2B
adel2B1 delay1 adel2B
afractdel2B=(adel2B*(1-ksmpfrac2B))+(adel2B1*ksmpfrac2B)
afractdel2B tone afractdel2B,klp
adel2C deltapn ksmpint2C
adel2C1 delay1 adel2C
afractdel2C=(adel2C*(1-ksmpfrac2C))+(adel2C1*ksmpfrac2C)
afractdel2C tone afractdel2C,klp
amix2=(aimpfilt+(garesFB*kresFB)+((afractdel2A+afractdel2B)*kmix2*.5)+(afractdel2C*(1-kmix2)))*kref
delayw amix2

;THIRD SET OF STRINGS
kpos3=ksmp3*kpos3
ksmpint3A=int(ksmp3+kpos3)
ksmpfrac3A=frac(ksmp3+kpos3)
ksmpint3B=int(ksmp3-kpos3)
ksmpfrac3B=frac(ksmp3-kpos3)
ksmpint3C=int(ksmp3)
ksmpfrac3C=frac(ksmp3)

abuf3A delayr 2.5
adel3A deltapn ksmpint3A
adel3A1 delay1 adel3A
afractdel3A=(adel3A*(1-ksmpfrac3A))+(adel3A1*ksmpfrac3A)
afractdel3A tone afractdel3A,klp
adel3B deltapn ksmpint3B
adel3B1 delay1 adel3B
afractdel3B=(adel3B*(1-ksmpfrac3B))+(adel3B1*ksmpfrac3B)
afractdel3B tone afractdel3B,klp
adel3C deltapn ksmpint3C
adel3C1 delay1 adel3C
afractdel3C=(adel3C*(1-ksmpfrac3C))+(adel3C1*ksmpfrac3C)
afractdel3C tone afractdel3C,klp
amix3=(aimpfilt+(garesFB*kresFB)+((afractdel3A+afractdel3B)*kmix3*.5)+(afractdel3C*(1-kmix3)))*kref
delayw amix3

aL=(amix1*(1-kpan1)*kamp1)+(amix2*(1-kpan2)*kamp2)+(amix3*(1-kpan3)*kamp3)
aR=(amix1*kpan1*kamp1)+(amix2*kpan2*kamp2)+(amix3*kpan3*kamp3)

ires1 chnget "res1"
ires2 chnget "res2"
ires3 chnget "res3"
ires4 chnget "res4"
iQ1 chnget "Q1"
iQ2 chnget "Q2"
iQ3 chnget "Q3"
iQ4 chnget "Q4"
iresamp1 chnget "resamp1"
iresamp2 chnget "resamp2"
iresamp3 chnget "resamp3"
iresamp4 chnget "resamp4"
astring=amix1+amix2+amix3
ar1 reson astring,ires1,ires1/iQ1
ar2 reson astring,ires2,ires2/iQ2
ar3 reson astring,ires3,ires3/iQ3
ar4 reson astring,ires4,ires4/iQ4
ar5 balance (ar1*iresamp1)+(ar2*iresamp2)+(ar3*iresamp3)+(ar4*iresamp4),astring
garesFB=ar5*kresFB ;this provides feedback into the strings to make a slightly more accurate model

;in addition to feeding back some resonance into the strings, can control independent resonance and body sound here:
aLr1 reson aL,ires1,ires1/iQ1
aLr2 reson aL,ires2,ires2/iQ2
aLr3 reson aL,ires3,ires3/iQ3
aLr4 reson aL,ires4,ires4/iQ4
aLr5 balance (aLr1*iresamp1)+(aLr2*iresamp2)+(aLr3*iresamp3)+(aLr4*iresamp4),aL
aLrev reverb aLr5,krevtime
aRr1 reson aR,ires1,ires1/iQ1
aRr2 reson aR,ires2,ires2/iQ2
aRr3 reson aR,ires3,ires3/iQ3
aRr4 reson aR,ires4,ires4/iQ4
aRr5 balance aRr1+aRr2+aRr3+aRr4,aL
aRrev reverb aRr5,krevtime

gafinalL=((aL*kenv*.5*kvol)*(1-kresmix))+(aLrev*kresmix*kresenv)+gafinalL
gafinalR=((aR*kenv*.5*kvol)*(1-kresmix))+(aRrev*kresmix*kresenv)+gafinalR
gafinalL dcblock gafinalL
gafinalR dcblock gafinalR
outs gafinalL,gafinalR

endin

instr 600	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "Stringy_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL, gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 750   ;clear global audio paths that include feedback (don't need to clear the global LFO outputs)
clear   gafinalL,gafinalR,garesFB,gamicL,gamicR
endin

</CsInstruments>
<CsScore>
;causes Csound to run for about 7000 years...
f0 z
f1 0 8193 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 ;saw
f2 0 8193 10 1 ;sine
f3 0 8193 10 1 0 .333 0 .2 0 .1444 0 .1111 0 .09999 ;square
f4 0 8193 10 1 1 1 1 1 1 1 1 1 1 .9 .7 .5 .3 .1 ;pulse

</CsScore>
</CsoundSynthesizer>
